  <template lang="html">
    <div class="">
     <v-container grid-list-lg fill-height justify-center align-center class="pa-0 ma-0">
       <v-layout row wrap align-center justify-center fill-height style="max-width: 1200px">
         <template wrap class="ma-0 pa-0" v-if="posts != null && posts.length > 0 || shadowPosts != null && shadowPosts.length > 0">
           <v-flex xs12 sm6 v-for="(i,index) in (shadowPosts || posts)" :key="i['.key']">
             <v-card>
               <v-card-media class="grey lighten-3 amber--text text--darken-3" :src="i.photo != '' ? i.photo : require('./img/noimage3.png')" height="300px" v-if="i.photo !=''">
                 <v-container fill-height fluid>
                    <v-layout fill-height>
                      <v-flex xs12 align-end flexbox>
                        <span class="headline">{{ i.title }}</span>
                      </v-flex>
                    </v-layout>
                  </v-container>
               </v-card-media>
               <v-card-text :style="i.photo == '' ? 'min-height: 402px; padding-top:22%' : ''">
                  <div v-if="i.photo == ''" class="mt-2 headline">{{ i.title }}</div>
                  <span :class="i.photo != '' ? 'headline' : 'grey--text'" style="word-break:break-all">{{ i.subTitle }}</span>
                  <v-divider class="mt-2" v-if="i.photo == ''"></v-divider>
                  <p :class="i.photo == '' ? 'mt-4' : 'grey--text'" style="word-break: break-all">{{i.description}}</p>
                </v-card-text>
                <v-divider></v-divider>
                <v-card-actions>
                  <v-btn icon @click="likePost(i)" v-if="i.author != uid">
                    <v-icon :color="i.likes.includes(uid) ? 'indigo' : 'grey darken-2'">favorite</v-icon>
                  </v-btn>
                  <v-btn icon v-else @click="deletePost(i['.key'])">
                    <v-icon color="grey darken-2">delete</v-icon>
                  </v-btn>
                  <v-spacer></v-spacer>
                  <span>{{ usernames[i.author] }}</span>
                  <v-menu left top :nudge-width="200" open-on-hover max-width="350px" v-if="i.author != uid">
                    <v-avatar size="32px" class="mx-2" slot="activator">
                      <img :src="pic[i.author]" v-if="pic[i.author] != null">
                      <img src="./img/blank-avatar.png" slot="activator" v-else>
                    </v-avatar>
                    <v-card>
                      <v-layout row wrap align-center justify-center>
                        <v-flex xs12 class="indigo text-xs-center" style="height: 100px">
                          <v-avatar size="64px" style="position:relative; top: 65px;">
                            <img :src="pic[i.author]" v-if="pic[i.author] != '' && pic[i.author] != null && pic[i.author] != undefined && pic != []">
                            <img src="./img/blank-avatar.png" v-else>
                          </v-avatar>
                        </v-flex>
                        <v-flex xs12>
                          <v-card-text class="mt-4 text-xs-center">
                            <h3 class="headline mb-3">{{usernames[i.author]}}</h3>
                            <span>{{occupations[i.author]}}</span>
                          </v-card-text>
                        </v-flex>
                        <v-card-actions class="pa-4">
                          <v-btn :dark="!followLoader" :loading="followLoader" :disabled="followLoader" :color="profile.following.includes(i.author) ? 'red' : 'indigo'" @click="followUser(i.author)">
                            <v-icon left size="18px"> {{profile.following.includes(i.author) ? 'cancel' : 'person_add'}}</v-icon>
                            {{profile.following.includes(i.author) ? 'unfollow' : 'follow'}}
                          </v-btn>
                          <v-btn outline color="blue darken-3" @click="$emit('checkProfile', i.author)">
                            <v-icon left size="18px">person</v-icon>
                            view profile
                          </v-btn>
                        </v-card-actions>
                      </v-layout>
                    </v-card>
                  </v-menu>
                  <v-avatar size="32px" class="mx-2" v-else>
                    <img :src="pic[i.author]" v-if="pic[i.author] != null">
                    <img src="./img/blank-avatar.png" slot="activator" v-else>
                  </v-avatar>
                </v-card-actions>
             </v-card>
           </v-flex>
         </template>
         <v-flex xs12 sm6 v-else>
           <v-layout fill-height row wrap justify-center>
             <v-flex xs12>
               <v-card flat class="text-xs-center grey lighten-5" style="height:calc(100vh - 100px); justify-content:center; align-items:center; display: flex">
                 <v-card-text>
                   <v-icon class="my-5" color="grey lighten-1" size="12vh">speaker_notes_off</v-icon><br>
                   <span class="headline grey--text">No posts found</span>
                 </v-card-text>
               </v-card>
             </v-flex>
           </v-layout>
         </v-flex>
       </v-layout>
     </v-container>
    </div>
  </template>

  <script>
  import {db} from './firebase';

  export default {
    data() {
      return {
        moreAbout: -1,
        pic: [],
        usernames: [],
        occupations: [],
        followLoader: false
      }
    },
    props: ['posts', 'shadowPosts', 'uid', 'profile'],
    watch: {
      posts: function(post) {
        var vm = this;
        post.forEach((p) => {
          db.ref('users').child(p.author).once('value').then((snapshot) => {
            if(snapshot.val() != null) {
              if(snapshot.val().picture != '' && snapshot.val().picture != null) {
                vm.$set(vm.pic, p.author, snapshot.val().picture)
              }
              if(snapshot.val().fullname != '' && snapshot.val().fullname != null) {
                vm.$set(vm.usernames, p.author, snapshot.val().fullname)
              }
              if(snapshot.val().occupation != '' && snapshot.val().occupation != null) {
                vm.$set(vm.occupations, p.author, snapshot.val().occupation)
              }
            }
          });
        });
      }
    },
    methods: {
      likePost(post) {
        var profile = this.uid;
        const copy = { ...post };
        delete copy['.key'];
        if(copy.likes != null && copy.likes != '') {
          var check = (copy.likes).split(",");
          if(check.includes(profile)) {
            check.splice(profile, 1);
            copy.likes = check.toString();
          } else {
            check.push(profile);
            copy.likes = check.toString();
          }
        } else {
          copy.likes = profile;
        }
        db.ref('posts/').child(post['.key']).set(copy);
      },
      deletePost(post) {
        db.ref('posts/').child(post).remove();
      },
      getPic(pic) {
        db.ref('/users/'+this.uid).once('value').then((snapshot) => {
          return snapshot.val().picture;
        });
      },
      followUser(user) {
        var vm = this;
        this.followLoader = true;
        db.ref('/users/'+this.uid).once('value').then((snapshot) => {
          var following = snapshot.val().following;
          var profile = snapshot.val();
          if(following != null && following != '') {
            var check = following;
            if(check.includes(user)) {
              check.splice(user, 1);
              if(check == '') {
                check = "";
              }
              profile.following = check;
            } else {
              check.push(user);
              profile.following = check;
            }
          } else {
            profile.following = user.split();
          }
          db.ref('users/').child(vm.uid).set(profile);
          this.profile = profile;
          this.$emit('updateProfile', this.profile);
          this.followLoader = false;
        });
      }
    }
  }
  </script>

  <style lang="css">
  </style>
